#include <typeinfo>
#include <iostream>
using namespace std;

#include "selection.h"

#include "mainwindow.h"
#include "vymmodel.h"



extern Main *mainWindow;

Selection::Selection()
{
	blocked=false;
	model=NULL;
}

Selection::~Selection()
{
}

void Selection::setModel (VymModel *m)
{
	model=m;
}

void Selection::update() // FIXME-2 VM emit signal in VM instead and get rid of this
{
/*
	QRectF bbox;
	//int w=0;
	for (int i=0; i< selectList.count(); ++i) 
	{
		bbox=selectList.at(i)->getBBox();
		selboxList.at(i)->setRect (
			bbox.x()-w,bbox.y()-w, 
			bbox.width()+2*w, bbox.height()+2*w);
		selboxList.at(i)->setPen (color);	
		selboxList.at(i)->setBrush (color);	
	}	
*/
}
bool Selection::select(LinkableMapObj *lmo)	// TODO no multiselections yet
{
	return model->select (lmo);
	/*
	if (!selectList.isEmpty()) unselect();
	selectList.append (lmo);
	lmo->select();
	update();
	mainWindow->updateSatellites (model);	
	cout << "Sel::select lmo e\n";
	return true;
	*/
}

bool Selection::select (const QString &s)	// TODO no multiselections yet
{
	return model->select (s);
	/*
	cout << "Sel::select s=\n";
	LinkableMapObj *lmo=model->findObjBySelect(s);

	// Finally select the found object
	if (lmo)
	{
		unselect();
		select (lmo);
		return true;
	} 
	return false;
	*/
}

bool Selection::reselect ()	// TODO no multiselections yet
{
	if (!lastSelectList.isEmpty())
	{
		select (lastSelectList.first());
		return true;
	}
	return false;

}

void Selection::unselect()
{
	model->unselect();
}

bool Selection::isBlocked()
{
	return blocked;
}

void Selection::block()
{
	blocked=true;
}

void Selection::unblock()
{
	blocked=false;
}

bool Selection::isEmpty()
{
	return selectList.isEmpty();
}

/*
uint Selection::count()
{
	return selectList.count();
}
*/

/*
Selection::Type Selection::type() // TODO no multiselections yet
{
	if (!selectList.isEmpty())
	{
		LinkableMapObj *sel=selectList.first();
		if (typeid (*sel)==typeid (BranchObj)) return Branch;
		if (typeid (*sel)==typeid (MapCenterObj)) return MapCenter;
		if (typeid (*sel)==typeid (FloatImageObj)) return FloatImage;
	}
	return Undefined;
}
*/

/*
LinkableMapObj* Selection::first()
{
	if (!selectList.isEmpty())
		return selectList.first();
	else	
		return NULL;
}

LinkableMapObj* Selection::single()
{
	if (selectList.count() == 1)
		return selectList.first();
	else	
		return NULL;
}

TreeItem* Selection::getBranchItem()
{
	BranchObj* bo=getBranch();
	if (bo) return bo->getTreeItem(); //  VM get directly from treemodl
	return NULL;
}

QModelIndex Selection::getBranchIndex()
{
	return model->getSelectionModel()->selectedIndexes().first();	// TODO no multiselections yet

}
*/

FloatImageObj* Selection::getFloatImage()
{
	if (!selectList.isEmpty())
	{
		LinkableMapObj *sel=selectList.first();
		if (typeid (*sel)==typeid (FloatImageObj)) 
			return (FloatImageObj*)sel;
	}
		return NULL;
}

QString Selection::getSelectString() // FIXME-2 VM this is also in VM ?! clean up here...
// TODO no multiselections yet
{
	if (selectList.count()==1)
	{
		return model->getSelectString (selectList.first() );
	}
	else
		return"";
}


