#ifndef VYMVIEW_H 
#define VYMVIEW_H

#include <QItemSelectionModel>
#include <QSplitter>
#include <QTreeView>

class VymModel;


class VymView : public QSplitter 
{
	Q_OBJECT
public:
	VymView(VymModel *model);
	QItemSelectionModel* selectionModel();

public slots:
	void updateChilds (QModelIndex ix);
	void changeSelection (const QItemSelection &newSel, const QItemSelection &delSel);

private:
	VymModel *model;
	QTreeView *treeview;
	QItemSelectionModel *selModel;
};


#endif

